/* Actions */
import {
    INIT_PAYMENTS_PURCHASES_JOURNALS,
    INIT_PAYMENTS_JOURNALS,
    RESET_PAYMENTS_PURCHASES_JOURNALS
 } from '@/constants/actionTypes'
/* Mutations*/
import {
    SET_JOURNALS,
    SET_LOADING_JOURNALS
} from '@/constants/mutationTypes'

const initialState = {
    journals : null,
    loadingJournals: false
}

const state = {
    journals: initialState.journals,
    loadingJournals: initialState.loadingJournals
}

const getters  = {
    /**
     * [journals description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    journals ( state ) {
        return state.journals
    },
    /**
     * [loadingJournals description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    loadingJournals( state ) {
        return state.loadingJournals
    }
}

const mutations = {
    /**
     * [journals description]
     * @type {[type]}
     */
    [SET_JOURNALS] (state, payload ) {
        state.journals = payload
    },
    /**
     * [loadingJournals description]
     * @type {[type]}
     */
    [SET_LOADING_JOURNALS] (state, payload) {
        state.loadingJournals = !!payload
    }
}

 const actions = {
     /**
      * [INIT_PAYMENTS_PURCHASES_JOURNALS]
      */
     [INIT_PAYMENTS_PURCHASES_JOURNALS] ({ commit, dispatch }, payload) {
         commit(SET_JOURNALS, payload)
         commit(SET_LOADING_JOURNALS, payload)

         dispatch(INIT_PAYMENTS_JOURNALS, payload)
     },
     /**
      * [RESET_PAYMENTS_PURCHASES_JOURNALS]
      */
     [RESET_PAYMENTS_PURCHASES_JOURNALS] ({ commit }) {
        commit(SET_JOURNALS, [])
        commit(SET_LOADING_JOURNALS, false)
     }
 }

 export default {
     state,
     getters,
     mutations,
     actions
 }
