//Actions
import {
    INIT_PAYMENTS_PURCHASES_SUPPLIER,
    FILTER_PAYMENTS_PURCHASES_SUPPLIER,
    SELECT_PAYMENTS_PURCHASES_SUPPLIER,
    INIT_SUPPLIER_INVOICES,
    RESET_PAYMENTS_PURCHASES_SUPPLIER
} from '@/constants/actionTypes'
// Mutations
import {
    SET_SUPPLIER,
    SET_LOADING_SUPPLIER ,
    SET_FILTER_PAYMENTS_PURCHASES_SUPPLIER,
    SET_SELECTED_PAYMENTS_PURCHASES_SUPPLIER
}from '@/constants/mutationTypes'

const initialState = {
    supplier: [],
    filterSupplier:[],
    loadingSupplier: false,
    selectedSupplier: null
}

const state = {
    supplier: initialState.supplier,
    loadingSupplier: initialState.loadingSupplier,
    filterSupplier: initialState.filterSupplier,
    selectedSupplier: initialState.selectedSupplier
}

const getters = {
    /**
     * [supplier description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    supplier ( state ) {
        return state.supplier
    },
    /**
     * [loadingSupplier description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    loadingSupplier ( state ) {
        return !state.loadingSupplier
    },
    /**
     * [selectedSupplier description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    selectedSupplier ( state ) {
        return state.selectedSupplier
    },
    /**
     * [supplierVisible description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    supplierVisible ( state ) {
        return state.filterSupplier.length === 0 ? state.supplier : state.filterSupplier
    }
}

const mutations = {
    /**
     * [supplier description]
     * @type {[type]}
     */
    [SET_SUPPLIER] (state, payload) {
        state.supplier = payload
    },
    /**
     * [loadingSupplier description]
     * @type {[type]}
     */
    [SET_LOADING_SUPPLIER] (state, payload) {
        state.loadingSupplier = payload
    },
    /**
     * [filterSupplier description]
     * @type {[type]}
     */
    [SET_FILTER_PAYMENTS_PURCHASES_SUPPLIER] (state, payload) {
        state.filterSupplier = payload
    },
    /**
     * [selectedSupplier description]
     * @type {[type]}
     */
    [SET_SELECTED_PAYMENTS_PURCHASES_SUPPLIER] ( state, payload ) {
        state.selectedSupplier = payload
    }
}

const actions = {
    /**
     * [INIT_PAYMENTS_PURCHASES_SUPPLIER]
     */
    [INIT_PAYMENTS_PURCHASES_SUPPLIER] ({ commit },payload) {
        commit(SET_SUPPLIER, payload)
        commit(SET_LOADING_SUPPLIER, payload)
    },
    /**
     * [ FILTER_PAYMENTS_PURCHASES_SUPPLIER ]
     */
    [FILTER_PAYMENTS_PURCHASES_SUPPLIER] ({ commit }, payload) {
        commit(SET_FILTER_PAYMENTS_PURCHASES_SUPPLIER, payload)
    },
    /**
     * [SELECT_PAYMENTS_PURCHASES_SUPPLIER]
     */
    [SELECT_PAYMENTS_PURCHASES_SUPPLIER] ({ commit, dispatch }, payload) {
        commit(SET_SELECTED_PAYMENTS_PURCHASES_SUPPLIER, payload)

        dispatch(INIT_SUPPLIER_INVOICES, payload.invoices)
    },
    /**
     * [RESET_PAYMENTS_PURCHASES_SUPPLIER]
     */
    [RESET_PAYMENTS_PURCHASES_SUPPLIER] ({ commit}) {
        commit(SET_SUPPLIER, [])
        commit(SET_LOADING_SUPPLIER, true)
        commit(SET_FILTER_PAYMENTS_PURCHASES_SUPPLIER, [])
        commit(SET_SELECTED_PAYMENTS_PURCHASES_SUPPLIER, null)
    }
}


export default {
    state,
    getters,
    mutations,
    actions
}
